<?php
function BidMenu($con, $GameID, $PlayerInGameID, $Turn)
{
  
  // check to see if a bid has been placed for teh current turn yet.
  
  $BidResult = mysqli_query($con, "SELECT Amount, Rate, TurnHistoryID, BidID FROM Bids WHERE PlayerInGameID=$PlayerInGameID AND Turn=$Turn;");
  if (!$BidResult)
  {
    //error
    return;
  }
      
  
  
  
  $MinCosts = array(0, 0, 0, 0, 0);
  $MaxCosts = array(0, 0, 0, 0, 0);
  $MinRevenue = array(0, 0, 0, 0, 0);
  $MaxRevenue = array(0, 0, 0, 0, 0);
  $MinProduced = array(0, 0, 0, 0, 0);
  $MaxProduced = array(0, 0, 0, 0, 0);  
  
  
  
  
  // Get the operating costs of coal and nuke
  $CostsResult = mysqli_query($con, "SELECT GameData.CoalOperating, GameData.GasOperating, GameData.NukeOperating, GameData.WindOperating, GameData.SolarOperating, GameData.CoalCapacity, GameData.GasCapacity, GameData.NukeCapacity, GameData.WindCapacity, GameData.SolarCapacity FROM GameData INNER JOIN Games WHERE Games.GameDataID=GameData.GameDataID LIMIT 1;");
  if ($CostsResult)
  {
    $CostsRow = mysqli_fetch_row($CostsResult);
    if ($CostsRow)
    {
      // Get your minimum operating costs.
      
      $PowerPlantsResult = mysqli_query($con, "SELECT Type FROM PowerPlants WHERE PlayerInGameID=$PlayerInGameID;");
      if ($PowerPlantsResult)
      { 
        while ($PowerPlantsRow = mysqli_fetch_row($PowerPlantsResult))
        {
          $PlantType=$PowerPlantsRow[0];
          
          $MaxCosts[$PlantType-1] = $MaxCosts[$PlantType-1] + $CostsRow[$PlantType-1];          // add in the max costs for this one.  
          $MaxProduced[$PlantType-1] = $MaxProduced[$PlantType-1] + $CostsRow[5+$PlantType-1];  // add in the maximum produced for this one                                        
        }
      }
    }
    
    // the minimum costs of coal and nuke are equal to the maximum because they cannot change.
    $MinCosts[0] = $MaxCosts[0];  //coal
    $MinCosts[2] = $MaxCosts[2];  //nuke
    
    $MinProduced[0] = $MaxProduced[0];  //coal
    $MinProduced[2] = $MaxProduced[2];  //nuke
  }
  
  $MinCapacity = array_sum($MinProduced);
  $MaxCapacity = array_sum($MaxProduced); 
  $YourMaxCapacity = $MaxProduced;
  
  
  $BidRow = mysqli_fetch_row($BidResult);

  
     
  if (!$BidRow) // no bid
  {
    echo "<P><I>You have not yet placed a bid. Minimum suggested values are shown.</I>";
    echo "<TABLE CLASS='Standard'><FORM action='bid.php' method='post' enctype='multipart/form-data'>";  
    $ButtonText = "Place New Bid";
    $SpecialMessage = "this";
    
    $Amount = $MinCapacity;
    $Rate = ceil(100*array_sum($MinCosts) / $MinCapacity)/100; // this gives me the result in $/MWh rounded up to two decimal places
      
    // the maximum produced of your gas is zero for this minimum default bid since it is off by default
    $MaxProduced[1] = 0;
    $MaxCosts[1] = 0;
    
    $MaxProduced[3] = 0;
    $MaxProduced[4] = 0;
        
  }
  else
  {
    echo "<P><I>The bid below has been placed:</I>";
    echo "<TABLE CLASS='Standard'><FORM action='changebid.php' method='post' enctype='multipart/form-data'>";
    $ButtonText = "Change Bid";
    $SpecialMessage = "your current";
    
    $Amount = $BidRow[0];
    $Rate = $BidRow[1];
                 
    echo "<INPUT TYPE='hidden' name='TurnHistoryID' value='" . $BidRow[2] . "'>";
    echo "<INPUT TYPE='hidden' name='BidID' value='" . $BidRow[3] . "'>";
    
    // now let's update the actual minimums and maximums for gas since it is flexible.
    if ($MaxProduced[1]>0)
    {
      // The true minimum is equal to the amount you bid minus the max amount produced from the other four.
      // but skip if there are no gas plants!  
      $MinProduced[1] = max(0, $Amount - $MaxProduced[0] - $MaxProduced[2] - $MaxProduced[3] - $MaxProduced[4]);
      $MinCosts[1] = ($MinProduced[1]/$MaxProduced[1]) * $MaxCosts[1]; // similarly the minimum costs are the equivalent fraction thereof.       
    
      // now lets calculate the maximum that has to come from gas.
      // IT is equal the the bid amount minus the minimums produced by the others
      $OldMaxProduced = $MaxProduced[1]; 
      $MaxProduced[1] = min($MaxProduced[1], $Amount - $MinProduced[0] - $MinProduced[2]);
      $MaxCosts[1] = ($MaxProduced[1]/$OldMaxProduced) * $MaxCosts[1];       
    }   
    
        
    $MaxProduced[3] = min( $MaxProduced[3], max(0, $Amount - $MinProduced[0] - $MinProduced[2]));
    $MaxProduced[4] = min( $MaxProduced[4], max(0, $Amount - $MinProduced[0] - $MinProduced[2]));
    
                                                   
  }
  
  
  
  
  echo "<INPUT TYPE='hidden' name='PlayerInGameID' value='$PlayerInGameID'>";
  echo "<INPUT TYPE='hidden' name='GameID' value='$GameID'>";
  echo "<INPUT TYPE='hidden' name='Turn' value='$Turn'>";
  echo "<INPUT TYPE='hidden' name='MinCapacity' value='$MinCapacity'>";
  echo "<INPUT TYPE='hidden' name='MaxCapacity' value='$MaxCapacity'>";
  echo "<TR><TH CLASS='Standard' style='text-align: left;'>Power You Pledge To Produce (MW)</TH><TD CLASS='Standard'><INPUT TYPE='text' size='5' length='5' name='Amount' value='$Amount'></TD><TD CLASS='Standard'><I>Allowed: $MinCapacity"."-"."$MaxCapacity</I></TD></TR>";
  echo "<TR><TH CLASS='Standard' style='text-align: left;'>Price You Will Sell it At (\$M/MWh)</TH><TD CLASS='Standard'><INPUT TYPE='text' size='5' length='5' name='Rate' value='$Rate'></TD><TD CLASS='Standard'><I>Allowed: 0.00-0.50</I></TD></TR>";
  echo "<TR><TD CLASS='Standard' COLSPAN=3' style='text-align: center;'><INPUT TYPE='submit' name='BidSumbit' value='$ButtonText' class='BidButton'></TD></TR></TABLE>";
  echo "</FORM>";
  echo "<DIV CLASS='rowspacer'> </DIV>";
  
  
  echo "<P><I>If you win $SpecialMessage bid, your plants will do the following:</I>";    
  echo "<TABLE CLASS='Standard'>";
  echo "<TR><TH Class='Standard'  style='text-align: left;'>Type</TH><TD Class='Standard' style='text-align: center;' ><B>Coal</B></TD><TD Class='Standard' style='text-align: center;' ><B>Gas</B></TD><TD Class='Standard' style='text-align: center;' ><B>Nuclear</B></TD><TD Class='Standard' style='text-align: center;' ><B>Wind</B></TD><TD Class='Standard' style='text-align: center;' ><B>Solar</B></TD><TD Class='Standard' style='text-align: center;' ><B>Total</B></TD></TR>";
  
   echo "<TR><TH Class='Standard'  style='text-align: left;'>Max Production (MW)</TH>";
  for ($i=0;$i<5;$i++)
  {
    echo "<TD CLASS='Standard'  style='text-align: center;'>";
    echo $YourMaxCapacity[$i];    
    echo "</TD>";
  }
  echo "<TD CLASS='Standard'  style='text-align: center;'>";
  echo $MaxCapacity;    
  echo "</TD>";  
  echo "</TR>";
  
  echo "<TR><TH Class='Standard'  style='text-align: left;'>Actual Production (MW)</TH>";
  for ($i=0;$i<5;$i++)
  {
    echo "<TD CLASS='Standard'  style='text-align: center;'>";
    if ($MinProduced[$i]==$MaxProduced[$i])
    {
      echo $MinProduced[$i];
    }
    else
    {
        echo $MinProduced[$i] ."-" . $MaxProduced[$i];
    }
    echo "</TD>";
  }  
  
  echo "<TD CLASS='Standard'  style='text-align: center;'>";
  
  $MinimumGuaranteedProduced = $MaxProduced[0] + $MaxProduced[1] + $MaxProduced[2];
  
  if ($MinimumGuaranteedProduced < $Amount)
  {
    echo "$MinimumGuaranteedProduced-"; 
  }
  echo $Amount;
  echo "</TD>";
  echo "</TR>";
  
  
  
  echo "<TR><TH Class='Standard'  style='text-align: left;'>Approx. Costs (\$M)</TH>";
  for ($i=0;$i<5;$i++)
  {
    echo "<TD CLASS='Standard'  style='text-align: center;'>";
    if ($MinCosts[$i]==$MaxCosts[$i])
    {
      echo $MinCosts[$i];
    }
    else
    {
        echo $MinCosts[$i] ."-" . $MaxCosts[$i];
    }
    echo "</TD>";
  }
  $TotalMaxCosts = array_sum($MaxCosts);
  $TotalMinCosts = array_sum($MinCosts);
    
  echo "<TD CLASS='Standard'  style='text-align: center;'>$TotalMinCosts";
  
  if ($TotalMaxCosts>$TotalMinCosts)
  {
    echo "-$TotalMaxCosts";
  }
      
  echo "</TD>";
  echo "</TR>";
  
  echo "<TR><TH Class='Standard'  style='text-align: left;'>Approx. Revenue (\$M)</TH>";
  $MaxPossibleRevenue = $Amount * $Rate ;
  for ($i=0;$i<5;$i++)
  {
    echo "<TD CLASS='Standard'  style='text-align: center;'>";
    $MinRevenue[$i] = $MinProduced[$i] * $Rate ;
    $MaxRevenue[$i] = $MaxProduced[$i] * $Rate ;
    if ($MinRevenue[$i]==$MaxRevenue[$i])
    {
      echo round(100*$MinRevenue[$i])/100;
    }
    else
    {
        echo  round(100*$MinRevenue[$i])/100 ."-" .  round(100*$MaxRevenue[$i])/100;
    }
    echo "</TD>";
  }  
  echo "<TD CLASS='Standard'  style='text-align: center;'>";
  if ($MinimumGuaranteedProduced < $Amount)
  {
    $MinimumGuaranteedRevenue = $MinimumGuaranteedProduced * $Rate;
    echo round($MinimumGuaranteedRevenue) . "-"; 
  }
  echo round($MaxPossibleRevenue);    
  echo "</TD>";
  echo "</TR>";
  echo "</TR>";
  
  
  if  ($Amount == $MinimumGuaranteedProduced)
  {
    // In this condition, you can always meet demand.  Costs change based on wind and solar
    $Note1 = "You can definitely produce all $Amount MW this turn";
    $Note2 = "(depends on the weather)"; 
    $Note3 = "Approx.";
    $MinProfit = round($MaxPossibleRevenue - $TotalMaxCosts,2);
    $MaxProfit = round($MaxPossibleRevenue - $TotalMinCosts,2);  
  }
  else
  {
    $Note1 = "You may not be able to produce up to " . ($Amount - $MinimumGuaranteedProduced) . "MW";
    $Note2 = "(depends on weather & other bids)";
    $Note3 = "Approx.";
    $MinProfit = round($MinimumGuaranteedRevenue - $TotalMaxCosts,2);
    $MaxProfit = round($MaxPossibleRevenue - $TotalMinCosts,2);
  }
  
  echo "<TR><TH Class='Standard'  style='text-align: left;'>$Note3 Profit (\$M)</TH>";
  echo "<TD CLASS='Standard'  style='text-align: center;' COLSPAN=6>";
  
  
  
  if ($MinProfit < $MaxProfit)
  {    
    echo "$MinProfit to ";
    if ($MinProfit < 0 and $MaxProfit>0)
    {
      echo "+";    
    } 
    echo $MaxProfit . " <I>$Note2</I>";
  }
  else
  {
    echo $MinProfit;
  }
  echo "</TD>";   
  echo "</TR>";
  
  echo "<TR><TH Class='Standard'  style='text-align: left;'>Important Note</TH>";
  echo "<TD CLASS='Standard'  style='text-align: center;' COLSPAN=6><I>";
  echo $Note1;
  echo "</I></TD>";   
  echo "</TR>";
  
  
  
  
  
  echo "</TABLE>";
    
  
   
}
?>
