<?php

function DrawMap($MapID, $MapURL, $NumRows, $NumCols, $GameID, $View, $con, $GameTime, $Cost=NULL, $Type=NULL, $PlayerInGameID=NULL, $Turn=NULL )
{
  if ($NumCols<1 or $NumCols > 100)
  {
    echo "<i>Error 1 drawing map $NumCols.</i>";
    return 0;
  }
  if ($NumRows<1 or $NumRows > 100)
  {
    echo "<i>Error 2 drawing map $NumRows.</i>";
    return 0;
  }  
  // NOTE THIS IS BROKEN!
  $CellWidth = round(820/$NumCols-1,0,PHP_ROUND_HALF_DOWN);  
  //$CellHeight = round(820/$NumRows-1,0,PHP_ROUND_HALF_DOWN);
  $CellHeight = 38;

  // make a big table with the background image
  
  // upper left row
  echo "<TABLE ID='Map' style='background-image: url(\"$MapURL\");'><TR><TD CLASS='MapSpacer'></TD>";
  
  // for the first row, print the column numbers  
  for ($c=1; $c<=$NumCols; $c++)
  {
     echo "<TD CLASS='MapHead' style='width: $CellWidth" . "px;'>$c</TH>";
  }
  echo "</TR>";
  
  
  $MapDataResult = mysqli_query($con, "SELECT Type, BuildPenalty, Wind, Sun FROM MapData WHERE MapID=$MapID ORDER BY X, Y ASC;");
  
  // also, get power plant rows, sorted
  $PowerPlantResult = mysqli_query($con, "SELECT Type, X, Y, Color FROM PowerPlants WHERE GameID=$GameID ORDER BY X, Y ASC;");
  
  // keep track of how many plants we are going to show.  This will alleviate some load.
  $PlantsRemaining = $PowerPlantResult->num_rows;
  
  // if there is at least one plant to plot, fetch the data.
  if ($PlantsRemaining > 0)
  {
    $PlantRow = mysqli_fetch_row($PowerPlantResult);
    $PlantType = $PlantRow[0];
    $PlantX = $PlantRow[1];
    $PlantY = $PlantRow[2];
    $PlantColor = $PlantRow[3];
  }
  
  
  // for each row
  for ($r=1; $r<=$NumRows; $r++)
  {
    // spit out the row number
    echo "<TR><TD CLASS='MapLeft' style='height: $CellHeight" . "px;'>$r</TD>";
    
    // for each cell
    for ($c=1; $c<=$NumCols; $c++)
    {
      // grey out the square if you can't build there
      echo "<TD CLASS='Map' style='width: $CellWidth" . "px; height: $CellHeight" . "px;'>";
       
      // draw/write the appropraite data based on the view
      $MapData = $MapDataResult->fetch_row();
      
      
      if ($View==0)            // Default
      {
        if ($MapData[0]==2) // nothing can be here
        {
          //echo "<IMG SRC='img/NoBuild.png' CLASS='NoBuild'>";
          // Do nothing here... only on the build map for the player
        }
        elseif ($MapData[0]<2 and $PlantsRemaining>0) // a building could exist here, so show it.
        {
          if ($r == $PlantX and $c == $PlantY) // oh, there is a plant here!
          {
             // draw it.
              if ($PlantColor < 10)
              {
                $ImgName = "0" . $PlantColor . "-" . $PlantType . ".png";
              }
              else
              {
                $ImgName = $PlantColor . "-" . $PlantType . ".png";
              }
              
              echo "<IMG SRC='img/" . $ImgName . "' CLASS='Grid'>";
            
             $PlantsRemaining = $PlantsRemaining - 1;
             // if there is at least one plant to plot, fetch the data.
             if ($PlantsRemaining > 0)
             {
                $PlantRow = mysqli_fetch_row($PowerPlantResult);
                $PlantType = $PlantRow[0];
                $PlantX = $PlantRow[1];
                $PlantY = $PlantRow[2];
                $PlantColor = $PlantRow[3];
            }
          }  
        }
        elseif ($MapData[0]==3) // a city tile
        {
          echo "<IMG SRC='img/city.png' CLASS='Grid'>";
          //echo $MapData[0];
        }
        
      }
      elseif ($View==2)   // Sun
      {
         if ($MapData[0]<2)
         {                   
           echo "<DIV CLASS='MapLabel" . $MapData[3] . "'><div class='Inner'>$MapData[3]</Div></DIV>";
         }
         elseif ($MapData[0]==3) // a city tile
         {
          echo "<IMG SRC='img/city.png' CLASS='Grid'>";
          //echo $MapData[0];
         } 
      }
      elseif ($View==3)   // Wind
      {
         if ($MapData[0]<2)
         {                   
           echo "<DIV CLASS='MapLabel" . $MapData[2] . "'><div class='Inner'>$MapData[2]</DIV></DIV>";
         }
         elseif ($MapData[0]==3) // a city tile
         {
          echo "<IMG SRC='img/city.png' CLASS='Grid'>";
          //echo $MapData[0];
         } 
      }
      elseif ($View==4)   // SunLand
      {
         if ($MapData[0]<2)
         {                   
           echo "<A CLASS='MapLabel'>$MapData[1]</A>";
         }
         elseif ($MapData[0]==3) // a city tile
         {
          echo "<IMG SRC='img/city.png' CLASS='Grid'>";
          //echo $MapData[0];
         } 
      }
      elseif($View==1) // WEATHER
      {
         if ($MapData[0]==3) // a city tile
         {
          echo "<IMG SRC='img/city.png' CLASS='Grid'>";
          //echo $MapData[0];
         }          
      }
      
      elseif ($View==6) // BuyMode
      {
        if (!is_null($Type))
        {         
          // if you can't biuld there...                 
          if ($MapData[0]==2) // nothing can be here
          {
            // Do nothing here... only on the build map for the player
            echo "<IMG SRC='img/NoBuild.png' CLASS='NoBuild'>";          
          }                    
          elseif ($MapData[0]==3) // a city tile, show that
          {
            echo "<IMG SRC='img/city.png' CLASS='Grid'>";
          }
          else
          {
            // if there is a building, show that.  Otherwise, show a the cost data as a button
          
            if ($PlantsRemaining>0 and $r == $PlantX and $c == $PlantY)
            {
              
              
                // draw it.
                if ($PlantColor < 10)
                {
                  $ImgName = "0" . $PlantColor . "-" . $PlantType . ".png";
                }
                else
                {
                  $ImgName = $PlantColor . "-" . $PlantType . ".png";
                }
              
                echo "<IMG SRC='img/" . $ImgName . "' CLASS='Grid'>";
            
                $PlantsRemaining = $PlantsRemaining - 1;
                // if there is at least one plant to plot, fetch the data.
                if ($PlantsRemaining > 0)
                {
                  $PlantRow = mysqli_fetch_row($PowerPlantResult);
                  $PlantType = $PlantRow[0];
                  $PlantX = $PlantRow[1];
                  $PlantY = $PlantRow[2];
                  $PlantColor = $PlantRow[3];
                }
             
                
            }
            elseif ($MapData[0]==1 and $Type<=3) // if there is no plant there, but the type is wrong, then put up a blocker          
            {
              echo "<IMG SRC='img/NoBuild.png' CLASS='NoBuild'>"; 
            }
            else // can build
            {
              $TotCost = $MapData[1] + $Cost;    
              
              if ($Type==4) // Wind
              {
                // add a splash of colour according to the windiness
                echo "<DIV CLASS='MapLabel" . $MapData[2] . "'><div class='Inner'>";
              }
              
              if ($Type==5) // sun
              {
                echo "<DIV CLASS='MapLabel" . $MapData[3] . "'><div class='Inner'>";
              }
              
              
                      
              echo "<FORM action='buyit.php' method='post' enctype='multipart/form-data'>";         
              echo "<INPUT TYPE='hidden' name='GameID' value='$GameID'>";  
              echo "<INPUT TYPE='hidden' name='TotalCost' value='$TotCost'>";
              echo "<INPUT TYPE='hidden' name='X' value='" . $r . "'>";
              echo "<INPUT TYPE='hidden' name='Y' value='" . $c . "'>";
              echo "<INPUT TYPE='hidden' name='Type' value='" . $Type . "'>";
              echo "<INPUT TYPE='hidden' name='PlayerInGameID' value='" . $PlayerInGameID . "'>";
              echo "<INPUT TYPE='hidden' name='Turn' value='" . $Turn . "'>";
              echo "<INPUT TYPE='submit' name='sub' value='" . $TotCost . "' class='MapButton'>";
            
              echo "</FORM>";
              
              if ($Type==5 or $Type==4)
              {
                echo "</div></DIV>";
              }
            }
            
           
          }
        }
        
      }
      
      
      
      echo "</TD>";
    
    }
    
    echo "</TR>"; 
  }
  
  echo "</TABLE>";
  
  
  // IF WE ARE SHOWING THE WEATHER, WE'LL NEED SOME OVERLAYS
  if ($View==1)
  {
    // get the four weather stations and their data
    $WeatherData = mysqli_query($con, "SELECT WeatherStationsInGames.Wind, WeatherStationsInGames.Sun, WeatherStations.X, WeatherStations.Y, WeatherStations.Name FROM WeatherStationsInGames INNER JOIN WeatherStations WHERE WeatherStations.WeatherStationID=WeatherStationsInGames.WeatherStationID AND WeatherStationsInGames.GameID=$GameID;");
    if ($WeatherData) // just skip if this doesn't work
    {
      while ($WeatherRow = mysqli_fetch_row($WeatherData)) // for each weather station
      {
        $Wind = $WeatherRow[0];
        $Sun = $WeatherRow[1];        
        $WX = $WeatherRow[2];
        $WY = $WeatherRow[3];
        $WName = $WeatherRow[4];
        
        // figure out which image
        // sun: 0.2 0.4 0.7  
        if ($Sun < 0.2)
        {
          if ($GameTime < 8 or $GameTime > 20)
          {
            $SunImg = "img/MoonRain_120.png";
          }
          else          
          {
            $SunImg = "img/Rain_120.png";
          }
        }
        if ($Sun < 0.4)
        {
          $SunImg = "img/Cloud_120.png";
          
        }
        elseif ($Sun < 0.7)
        {
          if ($GameTime < 8 or $GameTime > 20)
          {
            $SunImg = "img/MoonCloud_120.png";
          }
          else          
          {
            $SunImg = "img/Partcloudy_120.png";
          }
        }
        else
        {
          if ($GameTime < 8 or $GameTime > 20)
          {
            $SunImg = "img/Moon_120.png";
          }
          else          
          {
            $SunImg = "img/Sun_120.png";
          }
        }
        
        // compute overlay location in pixels
        // NOTE: Bad programming!  Any CSS changes will require a manual recode here.
        $Xpx = max(14, 16 + ($CellWidth+1)*($WY-2));
        $Ypx = max(14, ($CellHeight+3)*($WX-1));

        echo "<DIV Class='Weather' style='left: ".$Xpx. "px; top: ". $Ypx. "px;'><IMG SRC='$SunImg' CLASS='Grid'></DIV>";
        echo "<DIV Class='Weather' style='left: ".$Xpx. "px; top: ". $Ypx. "px;'>$WName</DIV>";
        
        if ($Wind >= 0.3) // add no wind logo if it is not windy
        {
          if ($Wind < 0.5)
          { 
            $WindImg = "img/LittleWindy_120.png";
          }
          elseif ($Wind<0.8)
          {
            $WindImg = "img/Windy_120.png";            
          }
          else
          {
            $WindImg = "img/VeryWindy_120.png";
          }
         
          $Xpx = $Xpx + 30;
          $Ypx = $Ypx + 30; 
          echo "<DIV Class='Weather' style='left: ".$Xpx. "px; top: ". $Ypx. "px;'><IMG SRC='$WindImg' CLASS='Grid'></DIV>";
      
        }
        
        
        
      }
      
      // show weather legend
      echo "<DIV CLASS='full'><TABLE CLASS='Legend'><TR><TD Class='Legend'></TD>";
      
      if ($GameTime < 8 or $GameTime > 20)
      {
        echo "<TD CLASS='Legend'><IMG SRC='img/MoonRain_40.png' CLASS='Legend'></TD>";
        echo "<TD CLASS='Legend'><IMG SRC='img/Cloud_40.png' CLASS='Legend'></TD>";
        echo "<TD CLASS='Legend'><IMG SRC='img/MoonCloud_40.png' CLASS='Legend'></TD>";
        echo "<TD CLASS='Legend'><IMG SRC='img/Moon_40.png' CLASS='Legend'></TD>";      
      }  
      else 
      {
        echo "<TD CLASS='Legend'><IMG SRC='img/Rain_40.png' CLASS='Legend'></TD>";
        echo "<TD CLASS='Legend'><IMG SRC='img/Cloud_40.png' CLASS='Legend'></TD>";
        echo "<TD CLASS='Legend'><IMG SRC='img/Partcloudy_40.png' CLASS='Legend'></TD>";
        echo "<TD CLASS='Legend'><IMG SRC='img/Sun_40.png' CLASS='Legend'></TD>";      
      }
      echo "<TD CLASS='Legend'> </TD>";
      echo "<TD CLASS='Legend'> </TD>";
      echo "<TD CLASS='Legend'> </TD>";
      echo "<TD CLASS='Legend'><IMG SRC='img/LittleWindy_40.png' CLASS='Legend'></TD>";
      echo "<TD CLASS='Legend'><IMG SRC='img/Windy_40.png' CLASS='Legend'></TD>";
      echo "<TD CLASS='Legend'><IMG SRC='img/VeryWindy_40.png' CLASS='Legend'></TD>";
      
      echo "</TR>";
      echo "<TH CLASS='Legend'>Skies:</TH><TD CLASS='Legend'>Rain</TD><TD CLASS='Legend'>Cloudy</TD><TD CLASS='Legend'>Partly Cloudy</TD><TD CLASS='Legend'>Clear</TD>";
      echo "<TD CLASS='Legend'> </TD><TH CLASS='Legend'>Wind:</TH><TD CLASS='Legend'>No Wind</TD><TD CLASS='Legend'>Breezy</TD><TD CLASS='Legend'>Windy</TD><TD CLASS='Legend'>High Winds</TD></TR>";
      echo "</TABLE></DIV>";  
    }  
  }
  elseif ($View==2 or $View==6 and $Type==5) // Legend for sun   
  {
          // show weather legend
      echo "<DIV CLASS='full'><TABLE CLASS='Legend'>";
      echo "<TH CLASS='Legend'>Annual Average Sunshine:</TH><TD CLASS='Legend'>Often Weak Sun</TD><TD CLASS='Legend'><IMG SRC='img/colourbar.png' CLASS='Legend'></TD><TD CLASS='Legend'>High Sun Intensity</TD></TR>";
      echo "</TABLE></DIV>";  
  }
  elseif ($View==3 or $View==6 and $Type==4) // Legend for wind   
  {
          // show weather legend
      echo "<DIV CLASS='full'><TABLE CLASS='Legend'>";
      echo "<TH CLASS='Legend'>Annual Average Wind:</TH><TD CLASS='Legend'>Usually Calm</TD><TD CLASS='Legend'><IMG SRC='img/colourbar.png' CLASS='Legend'></TD><TD CLASS='Legend'>Often Very Windy</TD></TR>";
      echo "</TABLE></DIV>";  
  }
  
  
  


}

?>